﻿using Microsoft.AspNetCore.Mvc;
using Send_Email_Core_MVC.Models;

using System.Net;
using System.Net.Mail;

namespace Send_Email_Core_MVC.Controllers
{
    public class HomeController : Controller
    {
        public IConfiguration Configuration { get; set; }
        public HomeController(IConfiguration configuration)
        {
            this.Configuration = configuration;
        }

        public IActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Index(EmailModel model)
        {
            //Read SMTP section from AppSetting.json.
            string host = this.Configuration.GetValue<string>("Smtp:Server");
            int port = this.Configuration.GetValue<int>("Smtp:Port");
            bool enableSsl = this.Configuration.GetValue<bool>("Smtp:EnableSsl");
            bool defaultCredentials = this.Configuration.GetValue<bool>("Smtp:DefaultCredentials");
            string from = this.Configuration.GetValue<string>("Smtp:From");
            string userName = this.Configuration.GetValue<string>("Smtp:Username");
            string password = this.Configuration.GetValue<string>("Smtp:Password");

            using (MailMessage mm = new MailMessage(from, model.To))
            {
                mm.Subject = model.Subject;
                mm.Body = model.Body;
                mm.IsBodyHtml = false;
                using (SmtpClient smtp = new SmtpClient())
                {
                    smtp.Host = host;
                    smtp.EnableSsl = enableSsl;
                    NetworkCredential networkCred = new NetworkCredential(userName, password);
                    smtp.UseDefaultCredentials = defaultCredentials;
                    smtp.Credentials = networkCred;
                    smtp.Port = port;
                    smtp.Send(mm);
                }
            }

            ViewBag.Message = "Email sent.";
            return View();
        }
    }
}
